#include "CFileManager.h"

std::vector<std::string> CFileManager::FindAllFiles(std::string Path)
{

	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;

	std::vector<std::string> FileVector;

	std::string TargetDir = Path;
	int iFind;

	iFind = -1;

	hFind = FindFirstFile( (TargetDir + "*.*").data() , &FindFileData);
	if (hFind == INVALID_HANDLE_VALUE) 
	{
		cPlugIn::Msgbox("Invalid File Handle" + Path);
	}
	else 
	{
	  if ((iFind !=0) && (FindFileData.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY))
		  FileVector.push_back(FindFileData.cFileName);
	}


	while (iFind != 0)
	{

	  iFind = FindNextFile(hFind, &FindFileData);
	  if (((iFind !=0) && FindFileData.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY))
		  FileVector.push_back(FindFileData.cFileName);
	}

	std::sort( FileVector.begin(), FileVector.end() );
	return FileVector;
}


std::string  CFileManager::LoadFile(std::string Path)
{
	std::ifstream inputFile( Path.c_str(), std::ios::in | std::ios::binary );
	if ( inputFile.fail())
	{
		//Error log here
		return "";
	}

	inputFile.seekg( 0, std::ios::end );
	long fileSize = inputFile.tellg();
	inputFile.seekg( 0, std::ios::beg );

	char *pBuffer = new char[fileSize];
	inputFile.read( pBuffer, fileSize );
	inputFile.close();

	std::string Content = pBuffer;
	delete[] pBuffer;

	return Content;

}
void  CFileManager::SaveFile(std::string Path, std::string Content)
{
	std::ofstream outputFile( Path.c_str(), std::ios::out);
	if (outputFile.write( Content.c_str(), Content.length() - 1 ) == false)
	{
		//Error log here
	}
	outputFile.close();
}
