#include "CGeometryManipulator.h"

#include <memory>
#include <vector>

void CGeometryManipulator::setVertexArray(float *VertexList, int ListSize)
{
	m_VertexList = new float[ListSize];
	memcpy(m_VertexList, VertexList, sizeof(float) * ListSize);
	m_VListSize = ListSize;

}
void CGeometryManipulator::setIndexArray(int *IndexList, int ListSize)
{
	m_IndexList = new int[ListSize];
	memcpy(m_IndexList, IndexList, sizeof(int) * ListSize);
	m_IListSize = ListSize;
}

void CGeometryManipulator::setTexCoordArray(float *TexCoordList, int ListSize)
{
	m_TexCoordList = new float[ListSize];
	memcpy(m_TexCoordList, TexCoordList, sizeof(float) * ListSize);
	m_TListSize = ListSize;
}

void CGeometryManipulator::getNormalArray(float *&NormalList)
{
	NormalList = new float[m_VListSize];
	memcpy(NormalList, m_NormalList, sizeof(float) * m_VListSize);	
}

void CGeometryManipulator::getIndexArray(int *&IndexList, int &ListSize)
{
	ListSize = m_IListSize;
	IndexList = new int[m_IListSize];
	memcpy(IndexList, m_IndexList, sizeof(int) * m_IListSize);	
}
void CGeometryManipulator::getVertexArray(float *&VertexList, int &ListSize)
{
	ListSize = m_VListSize;
	VertexList = new float[m_VListSize];
	memcpy(VertexList, m_VertexList, sizeof(float) * m_VListSize);	
}

void CGeometryManipulator::getTexCoordArray(float *&TexCoordList, int &ListSize)
{
	ListSize = m_TListSize;
	TexCoordList = new float[m_TListSize];
	memcpy(TexCoordList, m_TexCoordList, sizeof(float) * m_TListSize);
}

void CGeometryManipulator::createUniqueTriangles()
{
	float *NewVertexList = new float[m_IListSize * 3];
	int *NewIndexList = new int[m_IListSize];
	float *NewNormalList = new float[m_IListSize * 3];
//	float *NewTexCoordList = new float[m_IListSize * 2];

	for (int i = 0 ; i < m_IListSize ; i++)
	{
		NewVertexList[i * 3] = m_VertexList[m_IndexList[i] * 3];
		NewVertexList[i * 3 + 1] = m_VertexList[m_IndexList[i] * 3 + 1];
		NewVertexList[i * 3 + 2] = m_VertexList[m_IndexList[i] * 3 + 2];

//		NewTexCoordList[i * 2] = m_TexCoordList[m_IndexList[i] * 2];
//		NewTexCoordList[i * 2 + 1] = m_TexCoordList[m_IndexList[i] * 2 + 1];

		NewIndexList[i] = i;
		NewNormalList[i * 3] = m_NormalList[m_IndexList[i] * 3];
		NewNormalList[i * 3 + 1] = m_NormalList[m_IndexList[i] * 3 + 1];
		NewNormalList[i * 3 + 2] = m_NormalList[m_IndexList[i] * 3 + 2];
	}
	delete [] m_IndexList;
	delete [] m_VertexList;
	delete [] m_NormalList;
//	delete [] m_TexCoordList;

	m_VListSize = m_IListSize * 3;
//	m_TListSize = m_IListSize * 2;

//	m_TexCoordList = NewTexCoordList;
	m_IndexList = NewIndexList;
	m_VertexList = NewVertexList;
	m_NormalList = NewNormalList;
}

void CGeometryManipulator::createNormalTriangles()
{
	//std::vector<Point*> PointList;

//	point3 *FaceNormal = new point3[m_IListSize / 3];

//	point3 A, B, C;

	m_NormalList = new float[m_VListSize];


	for (int i = 0 ; i < m_VListSize ; i++)
	{
		m_NormalList[i] = 0;
	}
	/*

	//Point *CurrentPoint;
	int i = 0;
	while( i < m_IListSize )
	{
		A.Assign(m_VertexList[ m_IndexList[i] * 3], 
				 m_VertexList[ m_IndexList[i] * 3 + 1],
				 m_VertexList[ m_IndexList[i++] * 3 + 2]);

		B.Assign(m_VertexList[ m_IndexList[i] * 3], 
				 m_VertexList[ m_IndexList[i] * 3 + 1],
				 m_VertexList[ m_IndexList[i++] * 3 + 2]);

		C.Assign(m_VertexList[ m_IndexList[i] * 3], 
				 m_VertexList[ m_IndexList[i] * 3 + 1],
				 m_VertexList[ m_IndexList[i++] * 3 + 2]);


		FaceNormal[i / 3]  = (B-A)^(C-A);
		//FaceNormal[i / 3]  = (C-A)^(B-A);
		FaceNormal[i / 3].Normalize();
	}

	m_NormalList = new float[m_VListSize];

	for (i = 0 ; i < m_VListSize / 3 ; i++)
	{
		point3 sum;
		int TotalHit = 0;

		for (int j = 0 ; j < m_IListSize ; j++)
		{
			if (i == m_IndexList[j])
			{
				sum += FaceNormal[j / 3];
				TotalHit++;
			}

		}
		sum /= TotalHit;
		sum.Normalize();
		m_NormalList[i * 3] = sum.x;
		m_NormalList[i * 3 + 1] = sum.y;
		m_NormalList[i * 3 + 2] = sum.z;
	}
	*/

}
