#include "CModelLoader_3do.h"
#include "stdafx.h"
#include "msPlugInImpl.h"
#include <sstream>

//const long SCALE = 5000000;
//const long SCALE =10000;
const long SCALE =40000;


//struct MeshFinder : public std::unary_function<CJointTA::Mesh*, bool>
struct MeshFinder
{
	unsigned char m_RGBA[4];

	MeshFinder(unsigned char *RGBA)
	{
		//m_RGBA = new unsigned char[4];
		memcpy(m_RGBA, RGBA, sizeof(unsigned char) * 4);
	};
	bool operator()(CJointTA::Mesh* x) 
	{
		if (x->RGBA[0] == m_RGBA[0] && x->RGBA[1] == m_RGBA[1] && x->RGBA[2] == m_RGBA[2] && x->RGBA[3] == m_RGBA[3])
			return true;

		return false;
	}
};



int CJointTA::m_ParentCounter;
std::vector<CJointTA::Mesh*> CJointTA::m_MeshArray;
std::vector<CJointTA*> CJointTA::m_JointArray;

bool CModelLoader_3do::LoadModel(std::string Filename, std::string GafPath, bool isTextured)
{
	//Filename = CConstantManager::GetSingleton().GetConstant( PATH_TA_MODEL) + Filename;
	//Filename = "C:/Documents and Settings/Gendo Ikari/Desktop/VICE Tools/Demo Engine/data/Total Annihilation Data/Model/" + Filename;
	std::ifstream inputFile( (Filename).c_str(), std::ios::in | std::ios::binary); // | std::ios::nocreate
	if ( inputFile.fail())
	{
		return false;	// "Couldn't open the model file."
	}


	inputFile.seekg( 0, std::ios::end );
	long fileSize = inputFile.tellg() ;
	inputFile.seekg( 0, std::ios::beg );

	unsigned char *pBuffer = new unsigned char[fileSize];
	inputFile.read( (char*)pBuffer, fileSize );
	inputFile.close();

	const unsigned char *pPtr = pBuffer;

	OBJECT *pHeader = ( OBJECT* )pPtr;
	if (pHeader->VersionSignature != 1)
		return false;

	getTextureList(pPtr, pBuffer);

	std::sort( m_TextureList.begin(), m_TextureList.end() );
	std::vector<std::string>::iterator p = std::unique( m_TextureList.begin(), m_TextureList.end() );
	m_TextureList.erase(p, m_TextureList.end() );

	std::string ModelPath = Filename,
				ImageName;
	int LastSlash = 0;
	LastSlash = ModelPath.rfind("\\");
	ModelPath = ModelPath.substr(0, LastSlash) + "\\";

	ImageName = Filename.substr(LastSlash + 1, Filename.size() );
	LastSlash = ImageName.rfind(".");
	ImageName = ImageName.substr(0, LastSlash ) + ".bmp";


	CTextureLoader_GAF::CreateTextureList(m_TextureList, GafPath, ModelPath, ImageName, isTextured);

	m_RootJoint = new CJointTA;
	m_RootJoint->m_ParentCounter = 0;
	m_RootJoint->m_ParentName = 0;
	m_RootJoint->m_JointArray.push_back(m_RootJoint);
	m_RootJoint->m_ParentName = m_RootJoint->m_ParentCounter++;
	m_RootJoint->m_JointArray.push_back(m_RootJoint);
	getJoints(pPtr, pBuffer, m_RootJoint, 0, 0, 0, 0);

	m_RootJoint->m_TextureName = ImageName;

	sortMeshVector();

	delete [] pBuffer;
	CPaletteLoader_PAL::shutdownPalette();

	return true;
}


std::string CModelLoader_3do::getJointName(const unsigned char *NamePointer)
{
	char *Name = ( char* )NamePointer;
	return Name;
}

float *CModelLoader_3do::getVertexList(const unsigned char *VertexPointer, int ListSize, float distX, float distY, float distZ)
{
	tagVERTEX *VertexList = ( tagVERTEX* )VertexPointer;
	float *fVertexList = new float[ListSize * 3];
	for (int i = 0 ; i < ListSize ; i++)
	{
		fVertexList[i * 3]	= (float)(VertexList[i].x + distX) / SCALE * -1.0f;
		fVertexList[i * 3 + 1]	= (float)(VertexList[i].y + distY) / SCALE;
		fVertexList[i * 3 + 2]	= (float)(VertexList[i].z + distZ) / SCALE;
	}
	return fVertexList;
}

void CModelLoader_3do::getIndexList(const unsigned char *IndexPointer, const unsigned char *BasePointer,
									int ListSize, int &IndexListSize, int *&ptrIndexList, float *&ptrTexCoordList)
{
	tagPRIMITIVE *IndexList = ( tagPRIMITIVE* )IndexPointer;
	IndexListSize = 0;

	std::vector<int> vIndexList;
	std::vector<float> vTextureCoordList;
	for (int i = 0 ; i < ListSize ; i++)
	{
		if (IndexList[i].NumberOfVertexIndexes >= 3)
		{
			IndexPointer = BasePointer + IndexList[i].OffsetToVertexIndexArray;
			short *sIndexList = ( short* )IndexPointer;

			for (int j = 1 ; j < IndexList[i].NumberOfVertexIndexes - 1; j+=1)
			{
				vIndexList.push_back((int)sIndexList[0]);
				vIndexList.push_back((int)sIndexList[j + 1]);
				vIndexList.push_back((int)sIndexList[j]);

				float u, v;
				if (IndexList[i].OffsetToTextureName != 0)
				{
					CTextureLoader_GAF::getTextureCoordinates(( char* )BasePointer + IndexList[i].OffsetToTextureName, 0, u, v );
					vTextureCoordList.push_back(u);
					vTextureCoordList.push_back(v);

					CTextureLoader_GAF::getTextureCoordinates(( char* )BasePointer + IndexList[i].OffsetToTextureName, (j + 1), u, v );
					vTextureCoordList.push_back(u);
					vTextureCoordList.push_back(v);

					CTextureLoader_GAF::getTextureCoordinates(( char* )BasePointer + IndexList[i].OffsetToTextureName, j, u, v );
					vTextureCoordList.push_back(u);
					vTextureCoordList.push_back(v);
				}
				else
				{
					u= (IndexList[i].Color_Index + 1) * -1;
					v= (IndexList[i].Color_Index + 1) * -1;
					vTextureCoordList.push_back(u);
					vTextureCoordList.push_back(v);
					vTextureCoordList.push_back(u);
					vTextureCoordList.push_back(v);
					vTextureCoordList.push_back(u);
					vTextureCoordList.push_back(v);
				}				

				
			}			

			IndexListSize += (IndexList[i].NumberOfVertexIndexes - 2) * 3;
		}
	}

	int *iIndexList = new int[vIndexList.size()];
	for (i = 0 ; i < vIndexList.size() ; i++)
	{
		iIndexList[i] = vIndexList[i];
	}


	float *fTexCoordList = new float[vTextureCoordList.size()];
	for (i = 0 ; i < vTextureCoordList.size() ; i++)
	{
		fTexCoordList[i] = vTextureCoordList[i];
	}

	ptrIndexList = iIndexList;
	ptrTexCoordList = fTexCoordList;
}

void CModelLoader_3do::getTextureList(const unsigned char *HeaderPointer, const unsigned char *BasePointer)
{
	OBJECT *pHeader = ( OBJECT* )HeaderPointer;
	HeaderPointer += sizeof( OBJECT );

	getTextureNameFromIndexList(BasePointer + pHeader->OffsetToPrimitiveArray, BasePointer, pHeader->NumberOfPrimitives);

	if (pHeader->OffsetToSiblingObject != NULL)
	{
		getTextureList(BasePointer + pHeader->OffsetToSiblingObject, BasePointer);
	}

	if (pHeader->OffsetToChildObject != NULL)
	{
		getTextureList(BasePointer + pHeader->OffsetToChildObject, BasePointer);
	}

}
void CModelLoader_3do::getTextureNameFromIndexList(const unsigned char *IndexPointer, const unsigned char *BasePointer, int ListSize)
{
	tagPRIMITIVE *IndexList = ( tagPRIMITIVE* )IndexPointer;

	for (int i = 0 ; i < ListSize ; i++)
	{
		if (IndexList[i].OffsetToTextureName != 0)
		{
			char *Name = ( char* )BasePointer + IndexList[i].OffsetToTextureName;
			m_TextureList.push_back(Name);
		}
	}
}

void CModelLoader_3do::getJoints(const unsigned char *HeaderPointer, const unsigned char *BasePointer, 
										   CJointTA *NewJoint, float distX, float distY, float distZ, int ParentID)
{
	OBJECT *pHeader = ( OBJECT* )HeaderPointer;
	HeaderPointer += sizeof( OBJECT );

	int distParentX = distX + pHeader->XFromParent,
		distParentY = distY + pHeader->YFromParent,
		distParentZ = distZ + pHeader->ZFromParent;


	int iIndexListSize;
	int *iIndexList;
	float *fTexCoord;
	getIndexList(BasePointer + pHeader->OffsetToPrimitiveArray, BasePointer, pHeader->NumberOfPrimitives, 
				 iIndexListSize, iIndexList, fTexCoord);

	int iVertexListSize = pHeader->NumberOfVertexes * 3;
	float *fVertexList = getVertexList(BasePointer + pHeader->OffsetToVertexArray, 
									   pHeader->NumberOfVertexes, distParentX, distParentY, distParentZ);

	int iTexCoordSize = iIndexListSize * 2;
	float *fNormalList;


	CGeometryManipulator::GetSingletonPtr()->setIndexArray(iIndexList, iIndexListSize);
	CGeometryManipulator::GetSingletonPtr()->setVertexArray(fVertexList, iVertexListSize);
//	CGeometryManipulator::GetSingletonPtr()->setTexCoordArray(fTexCoord, iTexCoordSize);

	CGeometryManipulator::GetSingletonPtr()->createNormalTriangles();
	CGeometryManipulator::GetSingletonPtr()->createUniqueTriangles();
	CGeometryManipulator::GetSingletonPtr()->getNormalArray(fNormalList);
	CGeometryManipulator::GetSingletonPtr()->getIndexArray(iIndexList, iIndexListSize);
	CGeometryManipulator::GetSingletonPtr()->getVertexArray(fVertexList, iVertexListSize);
//	CGeometryManipulator::GetSingletonPtr()->getTexCoordArray(fTexCoord, iTexCoordSize);


	NewJoint->setName(getJointName(BasePointer + pHeader->OffsetToObjectName));
	NewJoint->setVertexList(fVertexList, iVertexListSize);
	NewJoint->setNormalList(fNormalList);
	NewJoint->setIndexList(iIndexList, iIndexListSize);
	NewJoint->setTexCoordList(fTexCoord, iTexCoordSize);
	
	NewJoint->distX = (float)pHeader->XFromParent / SCALE * -1.0f;
	NewJoint->distY = (float)pHeader->YFromParent / SCALE;
	NewJoint->distZ = (float)pHeader->ZFromParent / SCALE;
	
	int iName = m_RootJoint->m_ParentCounter++;
	NewJoint->m_iName = iName;


	NewJoint->compile();


	if (pHeader->OffsetToSiblingObject != NULL)
	{
		NewJoint->m_Sibling = new CJointTA;
		NewJoint->m_Sibling->m_ParentName = ParentID;
		NewJoint->m_JointArray.push_back(NewJoint->m_Sibling);
		getJoints(BasePointer + pHeader->OffsetToSiblingObject, BasePointer, NewJoint->m_Sibling, 
				  distX, distY, distZ, ParentID);
	}

	if (pHeader->OffsetToChildObject != NULL)
	{
		NewJoint->m_Child = new CJointTA;
		NewJoint->m_Child->m_ParentName = iName;
		NewJoint->m_JointArray.push_back(NewJoint->m_Child);
		getJoints(BasePointer + pHeader->OffsetToChildObject, BasePointer, NewJoint->m_Child, 
				  distParentX, distParentY, distParentZ, iName);
	}
}

void CModelLoader_3do::sortMeshVector()
{
	std::vector<int> IndexList(m_RootJoint->m_MeshArray[0]->m_IndexList);
	std::vector<int> BoneIndex(m_RootJoint->m_MeshArray[0]->m_BoneIndex);
	std::vector<float> VertexList(m_RootJoint->m_MeshArray[0]->m_VertexList);
	std::vector<float> NormalList(m_RootJoint->m_MeshArray[0]->m_NormalList);
	std::vector<float> TexCoordList(m_RootJoint->m_MeshArray[0]->m_TexCoordList);

	m_RootJoint->m_MeshArray[0]->m_IndexList.clear();
	m_RootJoint->m_MeshArray[0]->m_BoneIndex.clear();
	m_RootJoint->m_MeshArray[0]->m_VertexList.clear();
	m_RootJoint->m_MeshArray[0]->m_NormalList.clear();
	m_RootJoint->m_MeshArray[0]->m_TexCoordList.clear();

	std::stringstream ss;
	ss.str("");
	int ColorNb = 0;

	for (int i = 0 ; i < IndexList.size() ; i++)
	{
		if (m_RootJoint->m_MeshArray[0]->m_TexCoordList[ i * 2] >= 0)
		{
			m_RootJoint->m_MeshArray[0]->m_IndexList.push_back( m_RootJoint->m_MeshArray[0]->m_IndexList.size() );

			m_RootJoint->m_MeshArray[0]->m_BoneIndex.push_back(BoneIndex[i]);

			m_RootJoint->m_MeshArray[0]->m_VertexList.push_back(VertexList[i * 3]);
			m_RootJoint->m_MeshArray[0]->m_VertexList.push_back(VertexList[i * 3 + 1]);
			m_RootJoint->m_MeshArray[0]->m_VertexList.push_back(VertexList[i * 3 + 2]);

			m_RootJoint->m_MeshArray[0]->m_NormalList.push_back(NormalList[i * 3]);
			m_RootJoint->m_MeshArray[0]->m_NormalList.push_back(NormalList[i * 3 + 1]);
			m_RootJoint->m_MeshArray[0]->m_NormalList.push_back(NormalList[i * 3 + 2]);

			m_RootJoint->m_MeshArray[0]->m_TexCoordList.push_back(TexCoordList[i * 2]);
			m_RootJoint->m_MeshArray[0]->m_TexCoordList.push_back(TexCoordList[i * 2 + 1]);
			m_RootJoint->m_MeshArray[0]->m_Name = "Textured Mesh";
		}
		else
		{
			unsigned char *RGBA = new unsigned char[4];
			memcpy(RGBA, CPaletteLoader_PAL::getIndexRgbaValue( (m_RootJoint->m_MeshArray[0]->m_TexCoordList[ i * 2] * -1) - 1), sizeof(unsigned char) * 4);

			
			std::vector<CJointTA::Mesh*>::iterator result = std::find_if(m_RootJoint->m_MeshArray.begin(), 
																	 m_RootJoint->m_MeshArray.end(), 
																	 MeshFinder(RGBA));
																	 

			if (result == m_RootJoint->m_MeshArray.end())
			{				
				m_RootJoint->m_MeshArray.push_back(new CJointTA::Mesh(RGBA) );

				result = m_RootJoint->m_MeshArray.end();
				result--;
			}
			

			(*result)->m_IndexList.push_back( (*result)->m_IndexList.size() );

			(*result)->m_BoneIndex.push_back(BoneIndex[i]);

			(*result)->m_VertexList.push_back(VertexList[i * 3]);
			(*result)->m_VertexList.push_back(VertexList[i * 3 + 1]);
			(*result)->m_VertexList.push_back(VertexList[i * 3 + 2]);

			(*result)->m_NormalList.push_back(NormalList[i * 3]);
			(*result)->m_NormalList.push_back(NormalList[i * 3 + 1]);
			(*result)->m_NormalList.push_back(NormalList[i * 3 + 2]);

			(*result)->m_TexCoordList.push_back(TexCoordList[i * 2]);
			(*result)->m_TexCoordList.push_back(TexCoordList[i * 2 + 1]);

			
			if ((*result)->m_Name == "")
			{
				ss.str("");
				ss << "Colored Mesh " << ColorNb++;
				(*result)->m_Name = ss.str();
			}
		}
	}
}

void CModelLoader_3do::Draw()
{
}

CJointTA::CJointTA()
{
	m_Child = NULL;
	m_Sibling = NULL;
}


void CJointTA::setName(std::string Name)
{
	m_Name = Name;
}
void CJointTA::setVertexList(float *VertexList, int ListSize)
{
	m_VertexSize = ListSize;
	m_VertexList = VertexList;
}
void CJointTA::setIndexList(int *IndexList, int ListSize)
{
	m_IndexSize = ListSize;
	m_IndexList = IndexList;
}
void CJointTA::setNormalList(float *NormalList)
{
	m_NormalList = NormalList;
}
void CJointTA::setChild(CJointTA *Child)
{
	m_Child = Child;
}
void CJointTA::setSibling(CJointTA *Sibling)
{
	m_Sibling = Sibling;
}
void CJointTA::setTexCoordList(float *TexCoordList, int ListSize)
{
	m_TexCoordList = TexCoordList;
	m_TexCoordSize = ListSize;
}

void CJointTA::compile()
{
	if (m_MeshArray.size() == 0)
	{
		m_MeshArray.push_back(new Mesh());
	}

	int increment = m_MeshArray[0]->m_VertexList.size() / 3 ;
	for (int i = 0 ; i < m_IndexSize ; i++)
	{
		m_IndexList[i] += increment;
		m_MeshArray[0]->m_IndexList.push_back( m_IndexList[i] );
	}

	for (i = 0 ; i < m_VertexSize ; i++)
	{
		m_MeshArray[0]->m_VertexList.push_back(m_VertexList[i]);
		m_MeshArray[0]->m_NormalList.push_back(m_NormalList[i]);
	}


	for (i = 0 ; i < m_TexCoordSize ; i++)
	{
		m_MeshArray[0]->m_TexCoordList.push_back(m_TexCoordList[i]);
	}

	for (i = 0 ; i < m_VertexSize / 3; i++)
	{
		m_MeshArray[0]->m_BoneIndex.push_back( m_iName );
	}

	delete [] m_IndexList;
	delete [] m_VertexList;
	delete [] m_NormalList;
	delete [] m_TexCoordList;
}

bool CJointTA::Mesh::operator == ( const Mesh in )
{
	if (RGBA[0] == in.RGBA[0] && RGBA[1] == in.RGBA[1] && 
		RGBA[2] == in.RGBA[2] && RGBA[3] == in.RGBA[3])
		return true;

	return false;
}

