#ifndef _C_MODEL_LOADER_3DO_H
#define _C_MODEL_LOADER_3DO_H

#pragma warning (disable:4786)
#include <string>
#include <vector>
#include <fstream>
#include <vector>
#include <algorithm>
#include "ITA_Headers.h"
#include "CGeometryManipulator.h"
#include "CTextureLoader_GAF.h"
#include "CPaletteLoader_PAL.h"


///#include "CMaterialUnit.h"
//#include "CTextureManager.h"

class CJointTA;

class CModelLoader_3do
{
public:
	//CMaterialUnit m_Material;

	std::vector<std::string> m_TextureList;

	CJointTA *m_RootJoint;
	bool LoadModel(std::string Filename, std::string GafPath, bool isTextured);
	void Draw();

	std::string getJointName(const unsigned char *NamePointer);
	float *		getVertexList(const unsigned char *VertexPointer, int ListSize, float distX, float distY, float distZ);
	void		getIndexList(const unsigned char *IndexPointer, const unsigned char *BasePointer,
							 int ListSize, int &IndexListSize, int *&ptrIndexList, float *&ptrTexCoordList);
	void		getJoints(const unsigned char *HeaderPointer, const unsigned char *BasePointer, CJointTA *NewJoint, 
						  float distX, float distY, float distZ, int ParentID);

	void		getTextureList(const unsigned char *HeaderPointer, const unsigned char *BasePointer);
	void		getTextureNameFromIndexList(const unsigned char *IndexPointer, const unsigned char *BasePointer, int ListSize);

	void		sortMeshVector();
};

class CJointTA
{
public:

	class Mesh
	{
	public:
		unsigned char RGBA[4];
		std::vector<int> m_IndexList;
		std::vector<int> m_BoneIndex;
		std::vector<float> m_VertexList;
		std::vector<float> m_NormalList;
		std::vector<float> m_TexCoordList;

		Mesh()
		{
			RGBA[0] = -1;
			RGBA[1] = -1;
			RGBA[2] = -1;
			RGBA[3] = -1;
		}

		Mesh(unsigned char *rgba)
		{
			memcpy(RGBA, rgba, sizeof(unsigned char) * 4);
		}

		bool operator == ( const Mesh in );

		std::string m_Name;
	};

	int m_IndexSize,
		m_VertexSize,
		m_TexCoordSize;

	int *m_IndexList;

	float *m_VertexList,
		  *m_NormalList,
		  *m_TexCoordList;

	std::string m_Name;
	std::string m_TextureName;

	int m_ParentName;
	int m_iName;


	float distX, distY, distZ;

	static int m_ParentCounter;
	static std::vector<Mesh*> m_MeshArray;
	static std::vector<CJointTA*> m_JointArray;

	CJointTA *m_Child;
	CJointTA *m_Sibling;

	void Draw();

	CJointTA();

	void setName(std::string Name);
	void setVertexList(float *VertexList, int ListSize);
	void setIndexList(int *IndexList, int ListSize);
	void setTexCoordList(float *TexCoordList, int ListSize);
	void setNormalList(float *NormalList);
	void setChild(CJointTA *Child);
	void setSibling(CJointTA *Sibling);

	void compile();
	//void setLocalRotation(float x, float y, float z);
	void setLocalTranslation(float x, float y, float z);
	//void setBoneNumber(int BoneNumber);
};

#endif
