#include "CTextParser.h"

std::string CTextParser::CurrentFile[4];
CTextParser::LookUpList CTextParser::CurrentList;


std::string CTextParser::FindKeyWordValue(std::string Text, std::string KeyWord)
{
	std::string RawText = ParseParameter(Text, KeyWord);

	int PosKeyWord = 0,
		PosEnd = 0;

	KeyWord = KeyWord + "=";

	PosKeyWord = RawText.find(KeyWord) + KeyWord.length();
	PosEnd = RawText.find(";", PosKeyWord);

		return RawText.substr(PosKeyWord, PosEnd - PosKeyWord);
}

std::vector<std::string> CTextParser::FindBracketsValues(std::string Text, std::string KeyWord)
{
	int PosKeyWord = 0,
		PosEnd = 0,
		SearchLimitStart = 0,
		SearchLimitEnd = 0;

	std::vector<std::string> Results;


	SearchLimitStart = Text.find("[" + KeyWord + "]") + KeyWord.length() + 2;
	SearchLimitEnd = Text.find("[/" + KeyWord + "]") - 1;

	PosKeyWord = SearchLimitStart + 2;


	while (PosKeyWord < SearchLimitEnd)
	{
		PosEnd = Text.find(";", PosKeyWord);
		Results.push_back( Text.substr(PosKeyWord, PosEnd - PosKeyWord) );
		PosKeyWord = PosEnd + 3;
	}

	return Results;
}


std::string CTextParser::GetFileContent(std::string FilePath)
{
	ifstream inputFile( FilePath.c_str(), ios::in | ios::binary | ios::nocreate );
	if ( inputFile.fail())
	{
		return "";
	}

	inputFile.seekg( 0, ios::end );
	long fileSize = inputFile.tellg();
	inputFile.seekg( 0, ios::beg );

	char *pBuffer = new char[fileSize];
	inputFile.read( pBuffer, fileSize );
	inputFile.close();

	std::string Content = pBuffer;
	delete[] pBuffer;

	return Content;
}

std::vector<std::string> CTextParser::FindArrayValues(std::string Text, std::string KeyWord)
{
	std::string RawText = ParseParameter(Text, KeyWord);

	int PosKeyWord = 0,
		PosEnd = 0,
		SearchLimitStart = 0,
		SearchLimitEnd = 0;

	std::vector<std::string> Results;

	//SearchLimitStart = RawText.find(KeyWord + "=") + KeyWord.length() + 6;
	SearchLimitStart = RawText.find(KeyWord + "=");
	SearchLimitStart = RawText.find("{", SearchLimitStart) + 1;

	SearchLimitEnd = RawText.find("};", SearchLimitStart) + 2;

	PosKeyWord = SearchLimitStart;

	while (PosKeyWord < SearchLimitEnd && PosEnd != -1)
	{
		PosEnd = RawText.find(",", PosKeyWord);
		if ( PosEnd != -1)
		{
			Results.push_back( RawText.substr(PosKeyWord, PosEnd - PosKeyWord) );
			PosKeyWord = PosEnd + 1;
		}
	}

	return Results;
}

bool CTextParser::GetFileSettings(std::string FilePath, int index)
{
	
	//if (FilePath == "C:/Documents and Settings/Gendo Ikari/Desktop/lesson01/data/Gui/Skins/Default.skin")
	//	CDialogBox::WARNING(CurrentFile[index],"Hola!");

	CurrentFile[index] = GetFileContent(FilePath);
	if (CurrentFile[index] == "")
		return false;
	else
		return true;
		
}

std::string CTextParser::FindKeyWordValue(std::string KeyWord, int index)
{
	return FindKeyWordValue(CurrentFile[index], KeyWord);
}

std::vector<std::string> CTextParser::FindArrayValues(std::string KeyWord, int index)
{
	return CTextParser::FindArrayValues(CurrentFile[index], KeyWord);
}


std::string CTextParser::ParseParameter(std::string Text, std::string &Param)
{
	int PosKeyWord = 0, 
		PosEnd = 0;

	std::string RawText = Text;
	std::vector<std::string> ParamList;

	PosKeyWord = Param.find("|");
	while (PosKeyWord != -1)
	{
		ParamList.push_back( Param.substr(PosEnd, PosKeyWord - PosEnd) );
		//std::string ddd = Param.substr(PosEnd, PosKeyWord - PosEnd);
		PosEnd = PosKeyWord + 1;
		PosKeyWord = Param.find("|", PosEnd);
	}
	ParamList.push_back( Param.substr(PosEnd, PosKeyWord) );
	std::string ddd = Param.substr(PosEnd, PosKeyWord);


	for(int i = 0 ; i < ParamList.size() - 1 ; i++)
	{
		if (i < CurrentList.ParamList.size() && CurrentList.ParamList[i] == ParamList[i])
		{

			RawText = CurrentList.Content[i];
		}
		else
		{
			if (i < CurrentList.ParamList.size())
			{
				CurrentList.ParamList[i] = ParamList[i];
				CurrentList.Content[i] = BracketsContent(RawText, ParamList[i]);
				for (int j = (i + 1) ; j < CurrentList.ParamList.size() ; j++)
				{
					CurrentList.ParamList[j].erase();
					CurrentList.Content[j].erase();
				}

			}
			else
			{
				CurrentList.ParamList.push_back( ParamList[i] );
				CurrentList.Content.push_back( BracketsContent(RawText, ParamList[i]) );
			}
			RawText = CurrentList.Content[i];
		}

	}

	Param = ParamList[ParamList.size() - 1];

	ParamList.clear();
	
	return RawText;
}

std::string CTextParser::BracketsContent(std::string Text, std::string Bracket)
{
	
	int SearchLimitStart = 0,
		SearchLimitEnd = 0;

	SearchLimitStart = Text.find("[" + Bracket + "]");
	SearchLimitEnd = Text.find("[/" + Bracket + "]") - 1;

	return Text.substr(SearchLimitStart, SearchLimitEnd - SearchLimitStart);
	
}

void CTextParser::Flush(int index)
{
	CurrentFile[index] = "";
	CurrentList.ParamList.clear();
	CurrentList.Content.clear();
}


std::string CTextParser::TextReplace(std::string Text, std::string OldText, std::string NewText)
{

	std::string RawData = Text;

	int SearchLimitStart = 0,
		SearchLimitEnd = 0;

	std::string left, right;

	SearchLimitStart = RawData.find(OldText);
	SearchLimitEnd = SearchLimitStart + OldText.length();

	while (SearchLimitStart != std::string::npos)
	{

		left = RawData.substr(0, SearchLimitStart);
		right = RawData.substr(SearchLimitEnd, RawData.length() - SearchLimitEnd );

		RawData = left + NewText + right;

		SearchLimitStart = RawData.find(OldText);	
		SearchLimitEnd = SearchLimitStart + OldText.length();
	}

	//return left + NewText + right;
	return RawData;

}
