#include "CTextureFactory.h"
#include <fstream>
//#include<windows.h>        // Windows header file.
#include<stdio.h>          // Standard input/output.
std::ofstream Result;

void CTextureFactory::SaveTextureUnit(std::string FileName, unsigned char* data, int sizeX, int sizeY)
{
   // Remember that bitmaps are made up of 3 parts, the info header,
   // the file header, and the image.  We will have to write each one.

   FILE *pFile;                  // Our file pointer.
   BITMAPINFOHEADER infoHeader;  // info header.
   BITMAPFILEHEADER fileHeader;  // file header.
   int index;                    // index for the for loop.
   unsigned char tempColors;     // Use to change image from RGB to BGR.

   pFile = fopen(FileName.c_str(), "wb");    // Open the file for write.

   //if(!pFile) { return 0; }

   // Define whats going in the infoHeader.
   infoHeader.biSize = sizeof(BITMAPINFOHEADER);
   infoHeader.biPlanes        = 1;
   infoHeader.biBitCount      = 24;
   infoHeader.biCompression   = BI_RGB;
   infoHeader.biSizeImage     = sizeX * abs(sizeY) * 3;
   infoHeader.biXPelsPerMeter = 0;
   infoHeader.biYPelsPerMeter = 0;
   infoHeader.biClrUsed       = 0;
   infoHeader.biClrImportant  = 0;
   infoHeader.biWidth         = sizeX;
   infoHeader.biHeight        = sizeY;

   // Define whats going in the file header.
   fileHeader.bfSize       = sizeof(BITMAPFILEHEADER);
   fileHeader.bfType       = 0x4D42;
   fileHeader.bfReserved1  = 0;
   fileHeader.bfReserved2  = 0;
   fileHeader.bfOffBits    = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);


   // Change image from RGB to BGR.  Thats how .bmp is saved.
   for(index = 0; index < infoHeader.biSizeImage; index += 3)
      {
         tempColors = data[index];
         data[index] = data[index + 2];
         data[index + 2] = tempColors;
      }

   // Now lets write to the file.
   // Write file header.
   fwrite(&fileHeader, 1, sizeof(BITMAPFILEHEADER), pFile);

   // Write info header.
   fwrite(&infoHeader, 1, sizeof(BITMAPINFOHEADER), pFile);

   // Write image.
   fwrite(data, 1, infoHeader.biSizeImage, pFile);

   // Last but not least close the file.
   fclose(pFile);
}