
#ifndef _C_TEXTURE_LOADER_GAF_H
#define _C_TEXTURE_LOADER_GAF_H

#pragma warning (disable:4786)
#include <string>
#include <vector>

#include "stdafx.h"
#include "msPlugInImpl.h"

#include "CModelLoader_3do.h"

class CTextureLoader_GAF
{
public:
	class Texture
	{
	public:
		~Texture();
		int m_sizeX, m_sizeY;
		std::string m_Name;
		unsigned char *m_data;
		float m_TexCoord[4][2];

		bool operator < ( const Texture& in );
		bool operator == ( const Texture& in );
	};
private:

	static std::string m_SaveDir;
	static std::vector<Texture*> m_TextureArray;
	static std::string m_CurrentFile;
	static std::string m_SaveFile;
//	static unsigned char* m_TAPal;

//	static void InitPalette();
	static void ConvertTo24Bit(Texture *&Original);
	static Texture *GetTexture(unsigned char *EntryBase, unsigned char *Base);
	static Texture *GetCompressedFrameData(unsigned char *FramePtr, int sizeX, int sizeY);
	static Texture *GetUnompressedFrameData(unsigned char *FramePtr, int sizeX, int sizeY);
	static void GetConsolidatedFrameData(std::vector<Texture*> &TextureArray);

public:
	static bool CreateTextureList(std::vector<std::string> TextureList, std::string DirName, std::string SaveDir, std::string UnitName, bool isTextured);
	static void getTextureCoordinates(std::string textureName, int index, float &u, float &v);
};

#endif
