#include "stdafx.h"
#include "resource.h"
#include "DlgOptions.h"

#include "CFileManager.h"
#include "CTextParser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//======================================================================
// constructor
//======================================================================
cDlgOptions::cDlgOptions(CWnd* pParent /*=NULL*/)
	: CDialog(IDD_OPTIONS, pParent)
{
	//{{AFX_DATA_INIT(cDlgOptions)
	//}}AFX_DATA_INIT
}

//======================================================================
// DoDataExchange
//======================================================================
void cDlgOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(cDlgOptions)
	//}}AFX_DATA_MAP
}



//======================================================================
// Message Map
//======================================================================
BEGIN_MESSAGE_MAP(cDlgOptions, CDialog)
	//{{AFX_MSG_MAP(cDlgOptions)
    ON_BN_CLICKED(IDC_BTBROWSE,     OnBrowse)
    ON_BN_CLICKED(IDC_BTBROWSE2,     OnBrowse2)
    ON_BN_CLICKED(IDC_BTMATERIALS,  OnMaterials)
    ON_BN_CLICKED(IDC_BTBONES,      OnBones)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



//======================================================================
// OnInitDialog
//======================================================================
BOOL cDlgOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
    CDialog::CenterWindow();

    m_nFlags = eMeshes | eMaterials | eBones;
    m_sPathName.Empty();

    CheckDlgButton (IDC_BTMESHES, TRUE);
    CheckDlgButton (IDC_BTMATERIALS, TRUE);
    CheckDlgButton (IDC_BTBONES, TRUE);



	
	std::string DefaultPath = CFileManager::LoadFile("C:/3doImporterSettings.txt");
	if (DefaultPath != "")
	{
		m_sPathName = (CTextParser::FindKeyWordValue(DefaultPath, "3DO_PATH")).c_str();
		m_sPathName2 = CTextParser::FindKeyWordValue(DefaultPath, "GAF_PATH");
	
		SetDlgItemText (IDC_FILENAME, m_sPathName);
		SetDlgItemText (IDC_FILENAME2, m_sPathName2.c_str());
	}

	return TRUE;
}

//======================================================================
// OnClose
//======================================================================
void cDlgOptions::OnClose() 
{
	OnCancel ();
}

//======================================================================
// OnCancel
//======================================================================
void cDlgOptions::OnCancel() 
{
	CDialog::OnCancel();
}

//======================================================================
// OnOK
//======================================================================
void cDlgOptions::OnOK() 
{
    //GetDlgItemText (IDC_FILENAME, m_sPathName);

    m_nFlags = 0;
    if (IsDlgButtonChecked (IDC_BTMESHES))
        m_nFlags |= eMeshes;
    if (IsDlgButtonChecked (IDC_BTMATERIALS))
        m_nFlags |= eMaterials;
    if (IsDlgButtonChecked (IDC_BTBONES))
        m_nFlags |= eBones;


	CString Path2;
    GetDlgItemText(IDC_FILENAME, m_sPathName);
    GetDlgItemText(IDC_FILENAME2, Path2);
	m_sPathName2 = Path2;

	std::string DefaultPath;

	DefaultPath = "3DO_PATH=" + m_sPathName + ";\n";
	DefaultPath += "GAF_PATH=" + m_sPathName2 + ";\n";

	CFileManager::SaveFile("C:/3doImporterSettings.txt", DefaultPath);

	CDialog::OnOK();
}

//======================================================================
// OnBrowse
//======================================================================
void cDlgOptions::OnBrowse() 
{
    //
    // choose filename
    //
    CFileDialog fileDlg (TRUE, "txt", NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST,
                         "Total Annihilation 3do Files (*.3do)|*.3do|All Files (*.*)|*.*||");
    if (!fileDlg.DoModal ())
        m_sPathName.Empty ();
    else
        m_sPathName = fileDlg.GetPathName ();

    SetDlgItemText (IDC_FILENAME, m_sPathName);
}

//======================================================================
// OnBrowse 2
//======================================================================
void cDlgOptions::OnBrowse2() 
{

    //
    // choose filename
    //
LPMALLOC pMalloc;

	char *FilePath = new char[MAX_PATH];
    // Gets the Shell's default allocator


    if (::SHGetMalloc(&pMalloc) == NOERROR)
    {
         BROWSEINFO bi;
         char pszBuffer[MAX_PATH];
         LPITEMIDLIST pidl;
         // Get help on BROWSEINFO struct - it's got all the bit settings.
         bi.hwndOwner = NULL;
         bi.pidlRoot = NULL;
         bi.pszDisplayName = pszBuffer;
         bi.lpszTitle = "Select a directory";
         bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
         bi.lpfn = NULL;
         bi.lParam = 0;
         // This next call issues the dialog box.
         if ((pidl = ::SHBrowseForFolder(&bi)) != NULL)
         {
              //if (::SHGetPathFromIDList(pidl, m_sPathName2.GetBuffer(MAX_PATH)))
			 if (::SHGetPathFromIDList(pidl, FilePath) )
              { 
              // At this point pszBuffer contains the selected path
				m_sPathName2 = FilePath;
              }
			 else 
				 m_sPathName2 = "";
              // Free the PIDL allocated by SHBrowseForFolder.
              pMalloc->Free(pidl);
         }
         // Release the shell's allocator.
         pMalloc->Release();
    } 


    //m_sPathName2 = m_SourcePath;
	SetDlgItemText (IDC_FILENAME2, m_sPathName2.c_str());

}

//======================================================================
// OnBones
//======================================================================
void cDlgOptions::OnBones() 
{
	/*
    if (IsDlgButtonChecked (IDC_BTBONES))
    {
        //GetDlgItem (IDC_BTKEYFRAMES)->EnableWindow (TRUE);
    }
    else
    {
        //GetDlgItem (IDC_BTKEYFRAMES)->EnableWindow (FALSE);
        //CheckDlgButton (IDC_BTKEYFRAMES, FALSE);
    }
	*/
}

//======================================================================
// OnMaterials
//======================================================================
void cDlgOptions::OnMaterials() 
{
    if (IsDlgButtonChecked (IDC_BTMATERIALS))
    {
        GetDlgItem (IDC_BTBROWSE2)->EnableWindow (TRUE);
        GetDlgItem (IDC_FILENAME2)->EnableWindow (TRUE);
    }
    else
    {
        GetDlgItem (IDC_BTBROWSE2)->EnableWindow (FALSE);
        GetDlgItem (IDC_FILENAME2)->EnableWindow (FALSE);

        //CheckDlgButton (IDC_BTNOTRANSPARENCY, FALSE);
    }
}

//======================================================================
// GetPathName
//======================================================================
CString cDlgOptions::GetPathName() 
{
    return m_sPathName;
}

std::string cDlgOptions::GetTexPathName()
{
    return m_sPathName2;
}


//======================================================================
// GetPathName
//======================================================================
int cDlgOptions::GetOptionFlags() 
{
    return m_nFlags;
}
