/* Copyright (C) Scott Bilas, 2000. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the copyright text
 * below is included in the resulting source code, for example:
 * "Portions Copyright (C) Scott Bilas, 2000"
 */

#ifndef __I_SINGLETON_H
#define __I_SINGLETON_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <cassert>

template <typename T> class ISingleton
{
    static T* ms_Singleton;

public:
    ISingleton( void )
    {
        assert( !ms_Singleton );
        int offset = (int)(T*)1 - (int)(ISingleton <T>*)(T*)1;
        ms_Singleton = (T*)((int)this + offset);
    }
   ~ISingleton( void )
        {  assert( ms_Singleton );  ms_Singleton = 0;  }
    static T& GetSingleton( void )
		{	if (!ms_Singleton )
				ms_Singleton = new T;

			return ( *ms_Singleton );  
		}
        //{  assert( ms_Singleton );  return ( *ms_Singleton );  }
    static T* GetSingletonPtr( void )
		{
			if (!ms_Singleton )
				ms_Singleton = new T;

			return ( ms_Singleton );  
		}
        //{  return ( ms_Singleton );  }
};

template <typename T> T* ISingleton <T>::ms_Singleton = 0;

#endif // __I_SINGLETON_H