#ifndef _TA_HEADER_H
#define _TA_HEADER_H

class OBJECT
{
public:

    long VersionSignature;
    long NumberOfVertexes;
    long NumberOfPrimitives;
    long UnknownFlag;
    long XFromParent;
    long YFromParent;
    long ZFromParent;
    long OffsetToObjectName;
    long Always_0;
    long OffsetToVertexArray;
    long OffsetToPrimitiveArray;
    long OffsetToSiblingObject;
    long OffsetToChildObject;
};

class tagPRIMITIVE
{
public:
    long Color_Index;
    long NumberOfVertexIndexes;
    long Always_0;
    long OffsetToVertexIndexArray;
    long OffsetToTextureName;
    long Unknown_1;
    long Unknown_2;
    long Unknown_3;    
};

class tagVERTEX
{
public:
    long x;
    long y;
    long z;
};

class GAFHEADER
{
public:
  long IDVersion;  /* Version stamp - always 0x00010100 */
  long Entries;    /* Number of items contained in this file */
  long Unknown1;   /* Always 0 */
};

class GAFENTRY
{
public:
  short Frames;    /* Number of frames in this entry */
  short Unknown1;  /* Unknown - always 1 */
  long Unknown2;   /* Unknown - always 0 */
  char Name[32];   /* Name of the entry */
};

class GAFFRAMEENTRY
{
public:
  long PtrFrameTable;  /* Pointer to frame data */
  long Unknown1;       /* Unknown - varies */
};

class GAFFRAMEDATA 
{
public:
  short Width;         /* Width of the frame */
  short Height;        /* Height of the frame */
  short XPos;          /* X offset */
  short YPos;          /* Y offset */
  char Unknown1;       /* Unknown - always 9 */
  char Compressed;     /* Compression flag */
  short FramePointers;  /* Count of subframes */
  long Unknown2;       /* Unknown - always 0 */
  long PtrFrameData;   /* Pointer to pixels or subframes */
  long Unknown3;       /* Unknown - value varies */
};


#endif